﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading
Imports System.IO
Imports System.Text.RegularExpressions

Module Module1

    Public Function IsIP(ByVal ip As String) As Boolean
        Return Regex.IsMatch(ip, "^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$")
    End Function

    Sub Main()
        Dim IP As String = ""
        Dim ret As Boolean = False
        Dim quitIP As Boolean = False
        Dim quit As Boolean = False
        Dim hHS As IntPtr
        Dim gVal As UInt16 = 0
        Dim oVal As Int16 = 0
        Dim gVarr As UInt16() = New UInt16(7) {}
        Dim oVarr As Int16() = New Int16(7) {}
        Dim ChCnt As Short = 8
        Dim Gain As Short = 0
        Dim ulleng As UInteger = 0
        Dim BufferStatus As UShort = 0
        Dim readsize As UInt32 = 0
        Dim TrigMode As Short = 0
        Dim targetCnt As UInt32 = 10000
        Dim sampleRate As Integer = 35000
        Dim DataTransMethod As Short = 0
        Dim AutoRun As Short = 0

        While quitIP = False
            Console.WriteLine("Please Enter IP!!")
            IP = Console.ReadLine()
            ret = IsIP(IP)

            If ret = False Then
                Console.WriteLine("Please enter the correct IP")
            Else
                quitIP = True
                Thread.Sleep(100)
            End If
        End While

        hHS = HSDAQNet.Sys.HS_Device_Create(IP)
        Console.WriteLine("HSDAQ SDK Ver= " & HSDAQNet.Sys.GetSDKVersion().ToString())
        Console.WriteLine("ET7H16 Firmware Ver= " & HSDAQNet.Sys.GetFirmwareVersion(hHS).ToString())
        ret = HSDAQNet.HSIO.HS_SetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun)
        HSDAQNet.HSIO.HS_GetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun)
        Console.WriteLine("Ch=" & ChCnt & ",Gain=" & Gain & ",TrigMode=" & TrigMode & ",sampleRate=" & sampleRate & ",targetCnt=" & targetCnt)

        For ch As Integer = 0 To 8 - 1
            HSDAQNet.Config.HS_ReadGainOffset(hHS, ch, Gain, gVal, oVal)
            gVarr(ch) = gVal
            oVarr(ch) = oVal
            Console.WriteLine("[ch" & ch & "]Gain = " & gVal & " , Offset = " & oVal)
        Next

        If Not ret Then
            Console.WriteLine("Error code1 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
        Else
            ret = HSDAQNet.HSIO.HS_StartAIScan(hHS)

            If ret = False Then
                Console.WriteLine("Error code2 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
            End If

            While quit = False
                ret = HSDAQNet.HSIO.HS_GetAIBufferStatus(hHS, BufferStatus, ulleng)

                If ret = False Then
                    Console.WriteLine("Error code3 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
                Else

                    If BufferStatus > 2 Then
                        Console.WriteLine("BufferStatus Error<" & BufferStatus & ">," & ulleng)
                        Exit While
                    End If

                    If (ulleng >= targetCnt And BufferStatus > 2) Then
                        quit = True
                    End If
                End If
            End While
            Dim FdataBuffer() As Single = New Single(((ulleng * (8 * 2))) - 1) {}
            readsize = HSDAQNet.HSIO.HS_GetAIBuffer(hHS, FdataBuffer, ulleng)
            HSDAQNet.HSIO.HS_StopAIScan(hHS)
            HSDAQNet.Sys.HS_Device_Release(hHS)
            Console.WriteLine(vbCrLf & "AP total read = " & readsize & vbCrLf)
        End If

        Console.WriteLine("Press 'Q' to quit program")


        While Console.ReadKey(True).Key <> ConsoleKey.Q
        End While
    End Sub

End Module
