﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading
Imports System.IO
Imports System.Text.RegularExpressions
Module Module1

    Public Function IsIP(ByVal ip As String) As Boolean
        Return Regex.IsMatch(ip, "^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$")
    End Function

    Sub Main()
        Dim quitIP As Boolean = False
        Dim ret As Boolean = False
        Dim quit As Boolean = False
        Dim IP As String = ""
        Dim hHS As IntPtr
        Dim dwDI As ULong = 0, dwDO As ULong = 0
        Dim TOTAL_DO_CHANNEL_NUMBER As Integer = 4

        While quitIP = False
            Console.WriteLine("Please Enter IP!!")
            IP = Console.ReadLine()
            ret = IsIP(IP)

            If ret = False Then
                Console.WriteLine("Please enter the correct IP")
            Else
                quitIP = True
                Thread.Sleep(100)
            End If
        End While

        hHS = HSDAQNet.Sys.HS_Device_Create(IP)
        Console.WriteLine("ET-7H16 Digital I/O WriteDObit Testing")
        Console.WriteLine("HSDAQ SDK Ver= " & HSDAQNet.Sys.GetSDKVersion().ToString())
        Console.WriteLine("ET7H16 Firmware Ver= " & HSDAQNet.Sys.GetFirmwareVersion(hHS).ToString())
        HSDAQNet.IO.ReadDIO(hHS, dwDI, dwDO)
        Console.WriteLine("Read DI=" & dwDI & " , DO=" & dwDO)
        Console.WriteLine("DO output test, press any key to continue...")

        While quit = False

            If Console.KeyAvailable Then
                quit = True
            End If
        End While

        For i As Integer = 0 To TOTAL_DO_CHANNEL_NUMBER - 1
            HSDAQNet.IO.WriteDOBit(hHS, i, True)
            HSDAQNet.IO.ReadDIO(hHS, dwDI, dwDO)
            Console.WriteLine("Read DO=0x" & dwDO)
            Thread.Sleep(10)
        Next

        For i As Integer = 0 To TOTAL_DO_CHANNEL_NUMBER - 1
            HSDAQNet.IO.WriteDOBit(hHS, i, False)
            HSDAQNet.IO.ReadDIO(hHS, dwDI, dwDO)
            Console.WriteLine("Read DO=0x" & dwDO)
            Thread.Sleep(10)
        Next

        HSDAQNet.Sys.HS_Device_Release(hHS)
        Console.WriteLine("Press 'Q' to quit program")


        While Console.ReadKey(True).Key <> ConsoleKey.Q
        End While
    End Sub

End Module
